#include <fstream.h>

const true = 1;
const false = 0;
const ice = 1;
const empty = 2;
const locked = 3;
typedef int* iArr;

iArr *Ice;
int iIceS;
int iSC=0;
int iR=0;

void LoadData()
{
 ifstream inpf("Ice.inp",ios::in);
 int i;
 int i1;
 char *chArr;

 inpf >> iIceS;

 Ice=new iArr[iIceS-1];
 for (i=0;i<=iIceS;i++)
     Ice[i]=new int[iIceS-1];

 for (i=0;i<=iIceS-1;i++)
 {
  inpf >> chArr;
  for (i1=0;i1<=iIceS-1;i1++){
      if (chArr[i1]=='0')
	 Ice[i][i1]=empty;
      if (chArr[i1]=='*') {
	 Ice[i][i1]=ice;
	 iSC++;
      }
  }
 }
}

int LonelySquare(int iL,int iEl)
{
 int iN=0;

 if (Ice[iL][iEl-1]==empty)
    iN++;
 if (Ice[iL][iEl+1]==empty)
    iN++;
 if (Ice[iL-1][iEl]==empty)
    iN++;
 if (Ice[iL+1][iEl]==empty)
    iN++;
 if (iN>=2)
    return true;
 else
    return false;
}

void Unlock()
{
 int iL;
 int iEl;

 for (iL=0;iL<=iIceS-1;iL++)
  {
      for (iEl=0;iEl<=iIceS-1;iEl++)
      {
	 if (Ice[iL][iEl]==locked)
	     Ice[iL][iEl]=empty;
      }
  }
}

void Process()
{
 int iL=0;
 int iEl=0;

 do {
  iR++;
  Unlock();
  for (iL=0;iL<=iIceS-1;iL++)
  {
      for (iEl=0;iEl<=iIceS-1;iEl++)
      {
	 if ((Ice[iL][iEl]==ice) &&
	     (LonelySquare(iL,iEl)))
	 {
	  iSC--;
	  Ice[iL][iEl]=locked;
	 }
	 if (iSC==0)
	    break;
      }
      if (iSC==0)
	 break;
  }
 } while (iSC>0);
}

void SaveResult()
{
 ofstream outf("Ice.out",ios::out);

 outf << iR;
}

void main()
{
 LoadData();
 Process();
 SaveResult();
}